<?php
// Standard WP check if direct
if (!function_exists('add_action')) {
    exit();
}

// Create all option settings
$toolkit_options = array(
    array(
        'name' => 'limit_admins',
        'description' => 'Limit the users who can view the Agency Toolkit Settings Page',
    ),
    array(
        'name' => 'maintenance_mode',
        'description' => 'Enable maintenance mode',
    ),
    array(
        'name' => 'enable_wp_debugger',
        'description' => 'Enable the WordPress debugger',
    ),
    array(
        'name' => 'limit_post_revisions',
        'description' => 'Limit or disable post revisions',
    ),
    array(
        'name' => 'backend_footer',
        'description' => 'Enable a custom agency footer with a name, URL and email in the WordPress Dashboard',
    ),
    array(
        'name' => 'backend_logo',
        'description' => 'Enable a custom agency logo on the WordPress login screen',
    ),
    array(
        'name' => 'remove_site_health',
        'description' => 'Limit the users who can view Site Health',
    ),
    array(
        'name' => 'disable_editors',
        'description' => 'Disable theme and plugin editors',
    ),
    array(
        'name' => 'disable_installs_and_updates',
        'description' => 'Limit the users who can install and update plugins and themes',
    ),
    array(
        'name' => 'disable_auto_update_emails',
        'description' => 'Disable admin notification emails',
    ),
    array(
        'name' => 'disable_xml_rpc',
        'description' => 'Disable XML-RPC',
    ),
    array(
        'name' => 'disable_self_pingback',
        'description' => 'Disable self-pingbacks',
    ),
    array(
        'name' => 'disable_pingback_trackback_emails',
        'description' => 'Disable pingback and trackback notification emails',
    ),
    array(
        'name' => 'disable_emoticons',
        'description' => 'Disable emoticons',
    ),
    array(
        'name' => 'remove_rsd_links',
        'description' => 'Remove RSD links',
    ),
    array(
        'name' => 'hide_wordpress_version',
        'description' => 'Hide WordPress version generator in front-end source code',
    ),
    array(
        'name' => 'secure_wpconfig',
        'description' => 'Secure the wp-config.php file using .htaccess',
    ),
    array(
        'name' => 'change_email_sender',
        'description' => 'Globally change email sender',
    ),
    array(
        'name' => 'disable_admin_email_verification',
        'description' => 'Disable Wordpress Admin Email Verification prompt',
    ),
    array(
        'name' => 'enable_plugin_update_admin_notifications',
        'description' => 'Select users who receive email notifications when specific plugins are updated',
    ),
    array(
        'name' => 'change_user_notifications_email',
        'description' => 'Change admin email address shared in user emails',
    ),
    array(
        'name' => 'stop_user_enumeration',
        'description' => 'Stop User Enumeration',
    ),
    array(
        'name' => 'checksum_verification_for_wordpress_core_files',
        'description' => 'Checksum verification for WordPress core files',
    ),
    array(
        'name' => 'disable_media_comments',
        'description' => 'Disable Media Comments',
    ),
    array(
        'name' => 'limit_users_modify_admin_email',
        'description' => 'Limit users who can modify Admin Email Address',
    ),
    array(
        'name' => 'disable_admin_notice',
        'description' => 'Override the Disable Admin Notices Individually plugin to show all admin notices',
    ),
);

// Add options menu
function inspry_toolkit_options_menu_item(){

    add_menu_page('Agency Toolkit Options', 'Agency Toolkit', 'manage_options', 'inspry-agency-toolkit', 'inspry_toolkit_options_page', 'dashicons-hammer', 80);
}
add_action('admin_menu', 'inspry_toolkit_options_menu_item');

// Register options
function inspry_toolkit_options_register(){

    // Get options
    global $toolkit_options;

    // Loop through each option to register
    foreach ($toolkit_options as $option) {
        // Register the option
        register_setting('inspry_toolkit_options_group', 'inspry_toolkit_' . $option["name"]);
    }

    // Add custom settings as well
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_backend_footer_agency_name');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_backend_footer_agency_url');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_backend_footer_agency_email');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_backend_logo_image');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_limit_post_revisions_number');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_enable_wp_debugger_log');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_enable_wp_debugger_display');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_limit_admins');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_limit_admins_list');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_maintenance_mode_heading');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_maintenance_mode_sentence');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_change_email_sender_address');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_change_email_sender_name');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_disable_installs_and_updates');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_disable_installs_and_updates_list');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_enable_plugin_update_admin_notifications');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_enable_plugin_update_admin_notifications_list');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_enable_plugin_update_admin_notifications_plugin_list');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_change_user_notifications_email_sender');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_stop_user_enumeration');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_checksum_verification_for_wordpress_core_files');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_checksum_verification_for_wordpress_core_files_email_send');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_remove_site_health');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_remove_site_health_user_list');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_disable_media_comments');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_limit_users_modify_admin_email_user_list');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_limit_users_modify_admin_email');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_disable_admin_notice_user_list');
    register_setting('inspry_toolkit_options_group', 'inspry_toolkit_disable_admin_notice');


}
add_action('admin_init', 'inspry_toolkit_options_register');

// Include media uploader script function
function inspry_toolkit_options_page_enqueue(){

    wp_enqueue_media();
    wp_register_script('inspry_toolkit_options_page_script', plugins_url('js/options-page-script.js', __FILE__), array('jquery'));
    wp_enqueue_script('inspry_toolkit_options_page_script');
}
add_action('admin_enqueue_scripts', 'inspry_toolkit_options_page_enqueue');

// Add settings page content
function inspry_toolkit_options_page(){

    // Check if user is admin
    if (is_admin()) {
        // Check if limit admins option is enabled and that list is not empty (to avoid an admin locking themselves out)

        if (get_option('inspry_toolkit_limit_admins') == 1 && !empty(get_option('inspry_toolkit_limit_admins_list'))) {
            // Check if this admin is included in the array
            if (in_array(get_current_user_id(), get_option('inspry_toolkit_limit_admins_list'))) {
                // Limit admins enabled and user is in list, display page
                inspry_toolkit_options_page_html();
            } else {
                // Limit admins enabled and user is not in list, display error
               inspry_toolkit_options_page_error();
            }
        } else {
            // Limit admins disabled and this user is an admin, display page
            inspry_toolkit_options_page_html();
        }
    } else {
        // User is not an admin role, display error
        inspry_toolkit_options_page_error();
    }
}

// Options page HTML and JS
function inspry_toolkit_options_page_html(){

    // Get options
    global $toolkit_options;
?>

    <div class="atp-option" style="display: flex; justify-content:space-between;">
        <div class="atp-form" style="width:48%;">
            <h2>Agency Toolkit Options</h2>
            <p>Check all of the options that you wish to enable or disable on this website.</p>
            <form method="post" action="options.php" id="inspry_toolkit_options_form">
                <?php settings_fields('inspry_toolkit_options_group'); ?>
                <?php do_settings_sections('inspry_toolkit_options_group'); ?>
                <table style="text-align: left;">
                    <?php
                    foreach ($toolkit_options as $option) {
                        // Get checked option
                        $checked = get_option('inspry_toolkit_' . $option["name"]);

                        // Determine if checked or not
                        if ($checked == 1) {
                            $checked = 'checked';
                        } else {
                            $checked = '';
                        }

                        // Display option
                    ?>
                        <tr valign="top" class="inspry_toolkit_option_row_<?php echo esc_attr($option['name']); ?>">
                            <td><input type="checkbox" id="<?php echo esc_attr('inspry_toolkit_' . $option["name"]); ?>" name="<?php echo esc_attr('inspry_toolkit_' . $option["name"]); ?>" value="1" <?php checked(1, get_option('inspry_toolkit_' . $option["name"]), false); ?> <?php echo esc_html($checked); ?> /></td>
                            <th scope="row"><label for="<?php echo esc_attr('inspry_toolkit_' . $option["name"]); ?>"><?php echo esc_html($option["description"]); ?></label></th>
                        </tr>
                        <?php

                        // Check if this option is one that will include custom settings
                        switch ($option['name']) {
                            case 'backend_footer':
                        ?>
                                <tr valign="top" class="inspry_toolkit_backend_footer_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Agency Name</span>
                                        <input type="text" name="inspry_toolkit_backend_footer_agency_name" value="<?php echo esc_attr(get_option('inspry_toolkit_backend_footer_agency_name')); ?>" />
                                    </td>
                                </tr>
                                <tr valign="top" class="inspry_toolkit_backend_footer_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Agency URL</span>
                                        <input type="text" name="inspry_toolkit_backend_footer_agency_url" value="<?php echo esc_url(get_option('inspry_toolkit_backend_footer_agency_url')); ?>" />
                                    </td>
                                </tr>
                                <tr valign="top" class="inspry_toolkit_backend_footer_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Agency Email</span>
                                        <input type="text" name="inspry_toolkit_backend_footer_agency_email" value="<?php echo esc_attr(get_option('inspry_toolkit_backend_footer_agency_email')); ?>" />
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'backend_logo':
                            ?>
                                <tr valign="top" class="inspry_toolkit_backend_logo_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Logo Image</span>
                                        <input type="text" name="inspry_toolkit_backend_logo_image" id="inspry_toolkit_backend_logo_image" value="<?php echo esc_url(get_option('inspry_toolkit_backend_logo_image')); ?>" />
                                        <input type="button" id="upload_backend_logo_image_button" class="button-primary" value="Insert Image" />
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'limit_post_revisions':
                            ?>
                                <tr valign="top" class="inspry_toolkit_limit_post_revisions_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Limit Amount</span>
                                        <select name="inspry_toolkit_limit_post_revisions_number">
                                            <option value="0" <?php if (get_option('inspry_toolkit_limit_post_revisions_number') == 0) {
                                                                    echo esc_attr('selected="selected"');
                                                                } ?>>0 - Disable</option>
                                            <option value="1" <?php if (get_option('inspry_toolkit_limit_post_revisions_number') == 1) {
                                                                    echo esc_attr('selected="selected"');
                                                                } ?>>1</option>
                                            <option value="3" <?php if (get_option('inspry_toolkit_limit_post_revisions_number') == 3) {
                                                                    echo esc_attr('selected="selected"');
                                                                } ?>>3</option>
                                            <option value="5" <?php if (get_option('inspry_toolkit_limit_post_revisions_number') == 5) {
                                                                    echo esc_attr('selected="selected"');
                                                                } ?>>5</option>
                                            <option value="10" <?php if (get_option('inspry_toolkit_limit_post_revisions_number') == 10) {
                                                                    echo esc_attr('selected="selected"');
                                                                } ?>>10</option>
                                            <option value="15" <?php if (get_option('inspry_toolkit_limit_post_revisions_number') == 15) {
                                                                    echo esc_attr('selected="selected"');
                                                                } ?>>15</option>
                                            <option value="20" <?php if (get_option('inspry_toolkit_limit_post_revisions_number') == 20) {
                                                                    echo esc_attr('selected="selected"');
                                                                } ?>>20</option>
                                        </select>
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'enable_wp_debugger':
                            ?>
                                <tr valign="top" class="inspry_toolkit_enable_wp_debugger_custom_option">
                                    <th></th>
                                    <td>
                                        <input type="checkbox" id="inspry_toolkit_enable_wp_debugger_log" name="inspry_toolkit_enable_wp_debugger_log" value="1" <?php checked(1, get_option('inspry_toolkit_enable_wp_debugger_log'), false); ?> <?php if (get_option('inspry_toolkit_enable_wp_debugger_log') == 1) {
                                                 echo esc_attr('checked');} ?> />
                                        <span style="font-weight: bold; display: inline-block;">Enable debugger log (logs to <?php echo esc_html($_SERVER['DOCUMENT_ROOT']); ?>wp-content/debug.log)</span>
                                    </td>
                                </tr>
                                <tr valign="top" class="inspry_toolkit_enable_wp_debugger_custom_option">
                                    <th></th>
                                    <td>
                                        <input type="checkbox" id="inspry_toolkit_enable_wp_debugger_display" name="inspry_toolkit_enable_wp_debugger_display" value="1" <?php checked(1, get_option('inspry_toolkit_enable_wp_debugger_display'), false); ?> <?php if (get_option('inspry_toolkit_enable_wp_debugger_display') == 1) {
                                                  echo esc_attr('checked');} ?> />
                                        <span style="font-weight: bold; display: inline-block;">Enable debugger display (displays errors on front-end)</span>
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'limit_admins':
                            ?>
                                <tr valign="top" class="inspry_toolkit_limit_admins_custom_option">
                                    <th></th>
                                    <td>
                                        <select name="inspry_toolkit_limit_admins_list[]" multiple="multiple">
                                            <?php
                                            $admins = get_users(array('role' => 'administrator', 'order' => 'ASC', 'orderby' => 'ID'));
                                            foreach ($admins as $admin) {
                                            ?>
                                                <option value="<?php echo esc_attr($admin->ID); ?>" <?php if (!empty(get_option('inspry_toolkit_limit_admins_list'))) {
                                                        if (in_array($admin->ID, get_option('inspry_toolkit_limit_admins_list'))) {
                                                            echo esc_attr('selected="selected"');
                                                        }
                                                    } ?>><?php echo esc_html($admin->user_login); ?></option>
                                            <?php
                                            }
                                            ?>
                                        </select>
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'disable_installs_and_updates':
                            ?>
                                <tr valign="top" class="inspry_toolkit_disable_installs_and_updates_custom_option">
                                    <th></th>
                                    <td>
                                        <select name="inspry_toolkit_disable_installs_and_updates_list[]" multiple="multiple">
                                            <?php
                                            $admins = get_users(array('role' => 'administrator', 'order' => 'ASC', 'orderby' => 'ID'));
                                            foreach ($admins as $admin) {
                                            ?>
                                                <option value="<?php echo esc_attr($admin->ID); ?>" <?php if (!empty(get_option('inspry_toolkit_disable_installs_and_updates_list'))) {
                                                    if (in_array($admin->ID, get_option('inspry_toolkit_disable_installs_and_updates_list'))) {
                                                        echo esc_attr('selected="selected"');
                                                    }
                                                } ?>><?php echo esc_html($admin->user_login); ?></option>
                                            <?php
                                            }
                                            ?>
                                        </select>
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'maintenance_mode':
                            ?>
                                <tr valign="top" class="inspry_toolkit_maintenance_mode_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Maintenance mode heading</span>
                                        <input type="text" name="inspry_toolkit_maintenance_mode_heading" value="<?php echo esc_attr(get_option('inspry_toolkit_maintenance_mode_heading')); ?>" />
                                    </td>
                                </tr>
                                <tr valign="top" class="inspry_toolkit_maintenance_mode_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Maintenance mode sentence</span>
                                        <input type="text" name="inspry_toolkit_maintenance_mode_sentence" value="<?php echo esc_attr(get_option('inspry_toolkit_maintenance_mode_sentence')); ?>" />
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'change_email_sender':
                            ?>
                                <tr valign="top" class="inspry_toolkit_change_email_sender_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Email sender address</span>
                                        <input type="text" name="inspry_toolkit_change_email_sender_address" value="<?php echo esc_attr(get_option('inspry_toolkit_change_email_sender_address')); ?>" />
                                    </td>
                                </tr>
                                <tr valign="top" class="inspry_toolkit_change_email_sender_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Email sender name</span>
                                        <input type="text" name="inspry_toolkit_change_email_sender_name" value="<?php echo esc_attr(get_option('inspry_toolkit_change_email_sender_name')); ?>" />
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'enable_plugin_update_admin_notifications':
                            ?>
                                <tr valign="top" class="inspry_toolkit_enable_plugin_update_admin_notifications_custom_option">
                                    <th></th>
                                    <td>
                                        <select name="inspry_toolkit_enable_plugin_update_admin_notifications_list[]" multiple="multiple">
                                            <?php
                                            $admins = get_users(array('role' => 'administrator', 'order' => 'ASC', 'orderby' => 'ID'));
                                            foreach ($admins as $admin) {
                                            ?>
                                                <option value="<?php echo esc_attr($admin->ID); ?>" <?php if (!empty(get_option('inspry_toolkit_enable_plugin_update_admin_notifications_list'))) {
                                                        if (in_array($admin->ID, get_option('inspry_toolkit_enable_plugin_update_admin_notifications_list'))) {
                                                            echo esc_attr('selected="selected"');
                                                        }
                                                    } ?>><?php echo esc_html($admin->user_login); ?></option>
                                            <?php
                                            }
                                            ?>
                                        </select>
                                    </td>
                                </tr>

                                <tr valign="top" class="inspry_toolkit_enable_plugin_update_admin_notifications_custom_option">
                                    <th></th>
                                    <td>
                                        <?php 
                                         $all_plugins = get_plugins();
                                         foreach ($all_plugins as $key => $val) {
                                            //print_r($val);
                                         }
                                        ?>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Select Plugins</span>
                                        <select name="inspry_toolkit_enable_plugin_update_admin_notifications_plugin_list[]" multiple="multiple">
                                            <?php
                                            $selcted_plugins = get_option('inspry_toolkit_enable_plugin_update_admin_notifications_plugin_list');
                                            // $active_plugins = get_option('active_plugins');
                                            foreach ($all_plugins as $key => $val) {
                                            ?>
                                                <option value="<?php echo esc_attr($key); ?>" <?php if (!empty($selcted_plugins )) {
                                                            if (in_array($key, $selcted_plugins )) {
                                                                echo esc_attr('selected="selected"');
                                                            }
                                                        } ?>><?php echo esc_html($val['Name']); ?></option>
                                            <?php
                                            }
                                            ?>
                                        </select>
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'change_user_notifications_email':
                            ?>
                                <tr valign="top" class="inspry_toolkit_change_user_notifications_email_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Change admin email address</span>
                                        <?php
                                        if (get_option('inspry_toolkit_change_user_notifications_email_sender') == '') {
                                            $admin_email = get_option('admin_email'); ?>
                                            <input type="text" name="inspry_toolkit_change_user_notifications_email_sender" value="<?php echo $admin_email;  ?>" />
                                        <?php } else { ?>
                                            <input type="text" name="inspry_toolkit_change_user_notifications_email_sender" value="<?php echo esc_attr(get_option('inspry_toolkit_change_user_notifications_email_sender')); ?>" />
                                        <?php
                                        } ?>
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'checksum_verification_for_wordpress_core_files':
                            ?>
                                <tr valign="top" class="inspry_toolkit_checksum_verification_for_wordpress_core_files_custom_option">
                                    <th></th>
                                    <td>
                                        <span style="font-weight: bold; width: 100px; display: inline-block;">Email address for notifications</span>
                                        <?php if (get_option('inspry_toolkit_checksum_verification_for_wordpress_core_files_email_send') == '') {
                                            $admin_email = get_option('admin_email'); ?>
                                            <input type="text" name="inspry_toolkit_checksum_verification_for_wordpress_core_files_email_send" value="<?php echo $admin_email; ?>" />
                                        <?php } else { ?>
                                            <input type="text" name="inspry_toolkit_checksum_verification_for_wordpress_core_files_email_send" value="<?php echo esc_attr(get_option('inspry_toolkit_checksum_verification_for_wordpress_core_files_email_send')); ?>" />
                                        <?php } ?>
                                    </td>
                                </tr>
                                <tr valign="top" class="inspry_toolkit_checksum_verification_for_wordpress_core_files_custom_option">
                                    <th></th>
                                    <td>
                                        <p class="description">
                                            <?php
                                            $timestamp = wp_next_scheduled('cron_called');
                                            if ($timestamp) {
                                                echo sprintf(
                                                    '%s: %s',
                                                    esc_html__('Next Run', 'inspry-toolkit'),
                                                    esc_html(date_i18n('m-d-Y h:i:s a', $timestamp + get_option('gmt_offset') * 3600))
                                                );
                                            }
                                            ?>
                                        </p>
                                    </td>
                                </tr>
                            <?php
                                break;

                            case 'remove_site_health':
                            ?>
                                <tr valign="top" class="inspry_toolkit_remove_site_health_custom_option">
                                    <th></th>
                                    <td>
                                        <select name="inspry_toolkit_remove_site_health_user_list[]" multiple="multiple">
                                            <?php
                                            $admins = get_users(array('role' => 'administrator', 'order' => 'ASC', 'orderby' => 'ID'));
                                            foreach ($admins as $admin) {
                                            ?>
                                                <option value="<?php echo esc_attr($admin->ID); ?>" <?php if (!empty(get_option('inspry_toolkit_remove_site_health_user_list'))) {
                                                        if (in_array($admin->ID, get_option('inspry_toolkit_remove_site_health_user_list'))) {
                                                            echo esc_attr('selected="selected"');
                                                        }
                                                    } ?>><?php echo esc_html($admin->user_login); ?></option>
                                            <?php
                                            }
                                            ?>
                                        </select>
                                    </td>
                                </tr>
                    <?php
                                break;

                            case 'limit_users_modify_admin_email':
                                ?>
                                    <tr valign="top" class="inspry_toolkit_limit_users_modify_admin_email_custom_option">
                                        <th></th>
                                        <td>
                                            <select name="inspry_toolkit_limit_users_modify_admin_email_user_list[]" multiple="multiple">
                                                <?php
                                                $admins = get_users(array('role' => 'administrator', 'order' => 'ASC', 'orderby' => 'ID'));
                                                foreach ($admins as $admin) {
                                                ?>
                                                    <option value="<?php echo esc_attr($admin->ID); ?>" <?php if (!empty(get_option('inspry_toolkit_limit_users_modify_admin_email_user_list'))) {
                                                            if (in_array($admin->ID, get_option('inspry_toolkit_limit_users_modify_admin_email_user_list'))) {
                                                                echo esc_attr('selected="selected"');
                                                            }
                                                        } ?>><?php echo esc_html($admin->user_login); ?></option>
                                                <?php
                                                }
                                                ?>
                                            </select>
                                        </td>
                                    </tr>
                                <?php
                            break;

                            case 'disable_admin_notice':
                                ?>
                                    <tr valign="top" class="inspry_toolkit_disable_admin_notice_custom_option">
                                        <th></th>
                                        <td>
                                            <select name="inspry_toolkit_disable_admin_notice_user_list[]" multiple="multiple">
                                                <?php
                                                $admins = get_users(array('role' => 'administrator', 'order' => 'ASC', 'orderby' => 'ID'));
                                                foreach ($admins as $admin) {
                                                ?>
                                                    <option value="<?php echo esc_attr($admin->ID); ?>" <?php if (!empty(get_option('inspry_toolkit_disable_admin_notice_user_list'))) {
                                                            if (in_array($admin->ID, get_option('inspry_toolkit_disable_admin_notice_user_list'))) {
                                                                echo esc_attr('selected="selected"');
                                                            }
                                                        } ?>><?php echo esc_html($admin->user_login); ?></option>
                                                <?php
                                                }
                                                ?>
                                            </select>
                                        </td>
                                    </tr>
                                <?php
                            break;
                        }
                    }
                    ?>
                </table>
                <?php submit_button(); ?>
            </form>
        </div>
        <div class="atp-tools" style="width:600px; padding-top:7px; padding-right: 16px;">
            <div class="metabox-holder">
                <div class="postbox">
                    <h3><span>Export Settings</span></h3>
                    <div class="inside">
                        <p>Export the plugin settings for this site as a .json file. This allows you to easily import the configuration into another site.</p>
                        <form method="post">
                            <p><input type="hidden" name="inspry_toolkit__action" value="export_settings" /></p>
                            <p>
                                <?php submit_button(__('Export'), 'secondary', 'export', false); ?>
                            </p>
                        </form>
                    </div><!-- .inside -->
                </div><!-- .postbox -->

                <div class="postbox">
                    <h3><span>Import Settings</span></h3>
                    <div class="inside">
                        <p>Import the plugin settings from a .json file. This file can be obtained by exporting the settings on another site.</p>
                        <form method="post" enctype="multipart/form-data">
                            <p>
                                <input type="file" name="import_file" required/>
                            </p>
                            <p>
                                <input type="hidden" name="inspry_toolkit_action" value="import_settings" />
                                <?php submit_button(__('Import'), 'secondary', 'import', false); ?>
                            </p>
                        </form>
                    </div><!-- .inside -->
                </div><!-- .postbox -->
            </div>
        </div>
    </div>
    <?php
}

// Options error page HTML
function inspry_toolkit_options_page_error(){
    
    ?>
        <h1>Not authorized</h1>
        <p>You are not authorized to view this page. Please contact the site admin for more information.</p>
    <?php
}
    ?>